<?php
//This sample code requires GuzzleHttp to be installed via composer in the vendor folder
//composer require guzzlehttp/guzzle

//To test this code, open https://your-instance.nimbuscloud.at/?r=/nimbus/dev-sample-dashboard&url= followed by
//the urlencoded target url, containing the {token} placeholder
//For instance: This script runs at https://localhost/dashboard-iframe/?token={token} then use the js function encodeURIComponent
//Result: https://your-instance.nimbuscloud.at/?r=/nimbus/dev-sample-dashboard&url=https%3A%2F%2Flocalhost%2Fdashboard-iframe%2F%3Ftoken%3D%7Btoken%7D

use GuzzleHttp\RequestOptions;

require_once 'vendor/autoload.php';

$nimbuscloudDomain = "xy.nimbuscloud.at";
$apiKey = "<myapikey>";

$token = $_GET["token"] ?? null;

if($token !== null) {
    $client = new \GuzzleHttp\Client();

    try {//Get infos from nimbucloud which user has logged in
        $response = $client->get("https://" . $nimbuscloudDomain . "/backend/v2/user/auth/sso/dashboard-iframe-token-info", [
            RequestOptions::HEADERS => [
                "Content-Type" => "application/json",
                "X-API-Key" => $apiKey
            ],
            RequestOptions::QUERY => [
                "token" => $token
            ]
        ]);
        $response = json_decode($response->getBody()->getContents(), true);//start session with user info, etc.
        var_dump($response);
    } catch (\GuzzleHttp\Exception\GuzzleException $e) {
        echo "Invalid token!";
    }
}
else {
    echo "No token supplied!";
}